aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
-rw-r--r--docker-compose.yml11
-rw-r--r--docker/leap/Dockerfile96
-rwxr-xr-xdocker/leap/entrypoint.sh96
3 files changed, 203 insertions, 0 deletions
diff --git a/docker-compose.yml b/docker-compose.yml
index 86b52b145..9291f32cd 100644
--- a/docker-compose.yml
+++ b/docker-compose.yml
@@ -96,6 +96,17 @@ services:
dockerfile: docker/focal/test-qt4.Dockerfile
context: .
+ leap:
+ << : *linux
+ hostname: leap
+ image: ${DOCKER_USER:-qbsbuild}/qbsdev:leap-5.15.2_1.19.2-0
+ build:
+ dockerfile: docker/leap/Dockerfile
+ context: .
+ args:
+ QT_VERSION: 5.15.2
+ QTCREATOR_VERSION: 4.15.2
+
windows:
image: ${DOCKER_USER:-qbsbuild}/qbsdev:windowsservercore-5.15.0_1.18.2-0
build:
diff --git a/docker/leap/Dockerfile b/docker/leap/Dockerfile
new file mode 100644
index 000000000..308f854ab
--- /dev/null
+++ b/docker/leap/Dockerfile
@@ -0,0 +1,96 @@
+#
+# Install Qt and Qbs for Linux
+#
+FROM opensuse/leap:15.3
+LABEL Description="OpenSUSE development environment for Qbs with Qt and various dependencies for testing Qbs modules and functionality"
+ARG QT_VERSION
+ARG QTCREATOR_VERSION
+
+# Allow colored output on command line.
+ENV TERM=xterm-color
+
+#
+# Make it possible to change UID/GID in the entrypoint script. The docker
+# container usually runs as root user on Linux hosts. When the Docker container
+# mounts a folder on the host and creates files there, those files would be
+# owned by root instead of the current user. Thus we create a user here who's
+# UID will be changed in the entrypoint script to match the UID of the current
+# host user.
+#
+ARG USER_UID=1000
+ARG USER_NAME=devel
+RUN zypper in -y \
+ ca-certificates \
+ sudo \
+ system-user-mail \
+ system-group-wheel && \
+ groupadd -g ${USER_UID} ${USER_NAME} && \
+ useradd -s /bin/bash -u ${USER_UID} -g ${USER_NAME} -o -c "" -m ${USER_NAME} && \
+ usermod -a -G wheel ${USER_NAME} && \
+ echo "%devel ALL = (ALL) NOPASSWD: ALL" >> /etc/sudoers
+
+COPY docker/leap/entrypoint.sh /sbin/entrypoint.sh
+ENTRYPOINT ["/sbin/entrypoint.sh"]
+
+# # Qbs build dependencies
+RUN zypper install -y \
+ bison \
+ capnproto \
+ ccache \
+ cmake \
+ command-not-found \
+ curl \
+ gcc10 \
+ gcc10-c++ \
+ glibc-devel-static \
+ flex \
+ fontconfig \
+ git \
+ gzip \
+ help2man \
+ icoutils \
+ libcapnp-devel \
+ libgthread-2_0-0 \
+ libfreetype6 \
+ Mesa-libGL-devel \
+ Mesa-libGL1 \
+ nanopb-devel \
+ ninja \
+ perl \
+ pkg-config \
+ psmisc \
+ python3-pip \
+ p7zip-full \
+ subversion \
+ tar \
+ unzip \
+ which \
+ zip && \
+ update-alternatives --install /usr/bin/gcc gcc /usr/bin/gcc-10 100 && \
+ update-alternatives --install /usr/bin/g++ g++ /usr/bin/g++-10 100 && \
+ pip install --upgrade pip && \
+ pip install beautifulsoup4 lxml
+
+#
+# Install Qt and Qbs for Linux from qt.io
+#
+COPY scripts/install-qt.sh install-qt.sh
+
+RUN ./install-qt.sh --version ${QT_VERSION} qtbase qtdeclarative qtscript qttools qtx11extras qtscxml qt5compat icu && \
+ ./install-qt.sh --version ${QTCREATOR_VERSION} qtcreator && \
+ echo "export PATH=/opt/Qt/${QT_VERSION}/gcc_64/bin:/opt/Qt/Tools/QtCreator/bin:\${PATH}" > /etc/profile.d/qt.sh
+
+ENV PATH=/opt/Qt/${QT_VERSION}/gcc_64/bin:/opt/Qt/Tools/QtCreator/bin:${PATH}
+
+# Configure Qbs
+USER $USER_NAME
+RUN qbs-setup-toolchains /usr/bin/g++ gcc && \
+ qbs-setup-qt /opt/Qt/${QT_VERSION}/gcc_64/bin/qmake qt-gcc_64 && \
+ qbs config profiles.qt-gcc_64.baseProfile gcc && \
+ qbs config defaultProfile qt-gcc_64
+
+# Switch back to root user for the entrypoint script.
+USER root
+
+# Work-around for QTBUG-79020
+RUN echo "export QT_NO_GLIB=1" >> /etc/profile.d/qt.sh
diff --git a/docker/leap/entrypoint.sh b/docker/leap/entrypoint.sh
new file mode 100755
index 000000000..a34926ca4
--- /dev/null
+++ b/docker/leap/entrypoint.sh
@@ -0,0 +1,96 @@
+#!/usr/bin/env bash
+set -e
+
+#############################################################################
+##
+## Copyright (C) 2019 Richard Weickelt <richard@weickelt.de>
+## Contact: https://www.qt.io/licensing/
+##
+## This file is part of Qbs.
+##
+## $QT_BEGIN_LICENSE:LGPL$
+## Commercial License Usage
+## Licensees holding valid commercial Qt licenses may use this file in
+## accordance with the commercial license agreement provided with the
+## Software or, alternatively, in accordance with the terms contained in
+## a written agreement between you and The Qt Company. For licensing terms
+## and conditions see https://www.qt.io/terms-conditions. For further
+## information use the contact form at https://www.qt.io/contact-us.
+##
+## GNU Lesser General Public License Usage
+## Alternatively, this file may be used under the terms of the GNU Lesser
+## General Public License version 3 as published by the Free Software
+## Foundation and appearing in the file LICENSE.LGPL3 included in the
+## packaging of this file. Please review the following information to
+## ensure the GNU Lesser General Public License version 3 requirements
+## will be met: https://www.gnu.org/licenses/lgpl-3.0.html.
+##
+## GNU General Public License Usage
+## Alternatively, this file may be used under the terms of the GNU
+## General Public License version 2.0 or (at your option) the GNU General
+## Public license version 3 or any later version approved by the KDE Free
+## Qt Foundation. The licenses are as published by the Free Software
+## Foundation and appearing in the file LICENSE.GPL2 and LICENSE.GPL3
+## included in the packaging of this file. Please review the following
+## information to ensure the GNU General Public License requirements will
+## be met: https://www.gnu.org/licenses/gpl-2.0.html and
+## https://www.gnu.org/licenses/gpl-3.0.html.
+##
+## $QT_END_LICENSE$
+##
+#############################################################################
+
+#
+# Entrypoint script when starting the container. The script checks the current
+# working directory and changes the uid/gid of developer/users to match whatever
+# is found in the working directory. This is useful to match the user and group
+# of mounted volumes into the container
+
+#
+# If not root, re-run script as root to fix ids
+#
+if [ "$(id -u)" != "0" ]; then
+ exec sudo -i /sbin/entrypoint.sh "$@"
+fi
+
+#
+# Try to determine the uid of the working directory and adjust the current
+# user's uid/gid accordingly.
+#
+USER_GID=${USER_GID:-$(stat -c "%g" .)}
+USER_UID=${USER_UID:-$(stat -c "%u" .)}
+USER_NAME=${USER_NAME:-devel}
+USER_GROUP=${USER_GROUP:-devel}
+EXEC=""
+export HOME=/home/${USER_NAME}
+
+#
+# This is a problem on Linux hosts when we mount a folder from the
+# user file system and write artifacts into that. Thus, we downgrade
+# the current user and make sure that the uid and gid matches the one
+# of the mounted project folder.
+#
+# This work-around is not needed on Windows hosts as Windows doesn't
+# have such a concept.
+#
+if [ "${USER_UID}" != "0" ]; then
+ if [ "$(id -u ${USER_NAME})" != "${USER_UID}" ]; then
+ usermod -o -u ${USER_UID} ${USER_NAME}
+ # After changing the user's uid, all files in user's home directory
+ # automatically get the new uid.
+ fi
+ current_gid=$(id -g ${USER_NAME})
+ if [ "$(id -g ${USER_NAME})" != "${USER_GID}" ]; then
+ groupmod -o -g ${USER_GID} ${USER_GROUP}
+ # Set the new gid on all files in the home directory that still have the
+ # old gid.
+ find /home/${USER_NAME} -gid "${current_gid}" ! -type l -exec chgrp ${USER_GID} {} \;
+ fi
+fi
+EXEC="exec sudo -u ${USER_NAME} -g ${USER_GROUP}"
+
+if [ -z "$1" ]; then
+ ${EXEC} bash -l
+else
+ ${EXEC} bash -l -c "$*"
+fi